Option Explicit On 
Option Strict On

Imports System.ComponentModel
Imports System.Windows.Forms
Imports System.Threading
Imports System.Net.Sockets
Imports clsWinsock


Public Class TCPIPTestForm
    Inherits System.Windows.Forms.Form

    Friend WithEvents TextBox1 As System.Windows.Forms.TextBox
    Private WithEvents cmdSend As System.Windows.Forms.Button
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents txtMyTCPPort As System.Windows.Forms.TextBox
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Private myPort As Integer ' TCP Port number of this computer ServerWinsock
    Friend WithEvents cboServer As System.Windows.Forms.ComboBox
    Friend WithEvents BtnClose As System.Windows.Forms.Button
    Private myServers() As String ' used to store pairs of DestinationComputer;TCPIPPortNo

    Public Sub New(ByVal TCPPort As String, ByVal ServerList As String)
        MyBase.New()
        ' Each TCPIPTestForm is initialised with its TCPPortno, that is the Port on which 
        ' it listens to TCPClients, and the list of other Servers and TCPPortNos
        myPort = CInt(TCPPort) ' convert to integer TCPPort number
        If ServerList <> "" Then
            ' Split the list of serverInfo which looks like "Sadec;91234|CanTho;91346|Hue;92738"
            ' into individual pairs of DestinationComputer;TCPIPPortNo
            myServers = ServerList.Split("|".ToCharArray)
        End If
        'This call is required by the Win Form Designer.
        InitializeComponent()
    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        Try
            If disposing Then
                If Not (components Is Nothing) Then
                    components.Dispose()
                End If
            End If
            MyBase.Dispose(disposing)
        Catch Ex As System.StackOverflowException
            Console.WriteLine("TCPIPTestForm: Error in Dispose")
        End Try
    End Sub

#Region " Windows Form Designer generated code "

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.Container
    Private WithEvents lstOutput As System.Windows.Forms.ListBox




    Dim WithEvents Form1 As System.Windows.Forms.Form

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Private Sub InitializeComponent()
        Me.cmdSend = New System.Windows.Forms.Button()
        Me.Label1 = New System.Windows.Forms.Label()
        Me.Label2 = New System.Windows.Forms.Label()
        Me.BtnClose = New System.Windows.Forms.Button()
        Me.txtMyTCPPort = New System.Windows.Forms.TextBox()
        Me.cboServer = New System.Windows.Forms.ComboBox()
        Me.lstOutput = New System.Windows.Forms.ListBox()
        Me.TextBox1 = New System.Windows.Forms.TextBox()
        Me.SuspendLayout()
        '
        'cmdSend
        '
        Me.cmdSend.Location = New System.Drawing.Point(632, 8)
        Me.cmdSend.Name = "cmdSend"
        Me.cmdSend.Size = New System.Drawing.Size(64, 24)
        Me.cmdSend.TabIndex = 0
        Me.cmdSend.Text = "Send"
        '
        'Label1
        '
        Me.Label1.Location = New System.Drawing.Point(8, 8)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(56, 24)
        Me.Label1.TabIndex = 9
        Me.Label1.Text = "My TCP Port"
        '
        'Label2
        '
        Me.Label2.Location = New System.Drawing.Point(120, 8)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(64, 32)
        Me.Label2.TabIndex = 12
        Me.Label2.Text = "Dest Server"
        '
        'BtnClose
        '
        Me.BtnClose.Location = New System.Drawing.Point(696, 8)
        Me.BtnClose.Name = "BtnClose"
        Me.BtnClose.Size = New System.Drawing.Size(48, 24)
        Me.BtnClose.TabIndex = 14
        Me.BtnClose.Text = "Close"
        '
        'txtMyTCPPort
        '
        Me.txtMyTCPPort.Location = New System.Drawing.Point(72, 8)
        Me.txtMyTCPPort.Name = "txtMyTCPPort"
        Me.txtMyTCPPort.Size = New System.Drawing.Size(32, 20)
        Me.txtMyTCPPort.TabIndex = 10
        Me.txtMyTCPPort.Text = "9111"
        '
        'cboServer
        '
        Me.cboServer.DropDownWidth = 72
        Me.cboServer.Location = New System.Drawing.Point(192, 8)
        Me.cboServer.Name = "cboServer"
        Me.cboServer.Size = New System.Drawing.Size(168, 21)
        Me.cboServer.TabIndex = 13
        Me.cboServer.Text = "ComboBox1"
        '
        'lstOutput
        '
        Me.lstOutput.Location = New System.Drawing.Point(8, 40)
        Me.lstOutput.Name = "lstOutput"
        Me.lstOutput.Size = New System.Drawing.Size(744, 147)
        Me.lstOutput.TabIndex = 7
        '
        'TextBox1
        '
        Me.TextBox1.Location = New System.Drawing.Point(368, 8)
        Me.TextBox1.Name = "TextBox1"
        Me.TextBox1.Size = New System.Drawing.Size(256, 20)
        Me.TextBox1.TabIndex = 8
        Me.TextBox1.Text = "Hello from Client"
        '
        'TCPIPTestForm
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(752, 194)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.BtnClose, Me.cboServer, Me.Label2, Me.txtMyTCPPort, Me.Label1, Me.TextBox1, Me.lstOutput, Me.cmdSend})
        Me.Name = "TCPIPTestForm"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.Manual
        Me.Text = "Client"
        Me.ResumeLayout(False)

    End Sub

#End Region


    Private Sub TCPIPTestForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Instantiate a Server winsock which listens on port number myPort
        Swinsock = New ServerWinsock(myPort)
        If Not myServers Is Nothing Then
            cboServer.Items.Clear()
            cboServer.Items.Add("ALL")
            Dim ServerName As String
            ' Add list of serverNames to combobox
            For Each ServerName In myServers
                cboServer.Items.Add(ServerName) ' eg: CanTho;91346
            Next
            cboServer.SelectedIndex = 0 ' make first item of combobox the default item
        End If
        txtMyTCPPort.Text = myPort.ToString ' display this Server's TCP Port number
    End Sub

    ' Variable for the ServerWinsock that can handle event
    Dim WithEvents Swinsock As ServerWinsock
    Private Sub Swinsock_OnMessage(ByVal IncomingMessage As String) Handles Swinsock.OnMessage
        ' Add incoming message to the listbox
        lstOutput.Items.Add(IncomingMessage)
    End Sub

    ' Variable for the ClientWinsock
    Dim winsock As ClientWinsock
    Protected Sub cmdSend_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdSend.Click
        Dim i As Integer
        If cboServer.Text = "ALL" Then
            ' Broadcast message to all servers contained in the combobox
            For i = 1 To cboServer.Items.Count - 1
                ' Instantiate a TCPClient object and use it to send the message to the server indicated
                winsock = New ClientWinsock(cboServer.Items(i).ToString, TextBox1.Text)
            Next
        Else
            ' Just send to the given server
            winsock = New ClientWinsock(cboServer.Text, TextBox1.Text)
        End If
    End Sub


    Private Sub BtnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnClose.Click
        Swinsock = Nothing  ' dispose the ServerWinsock object
        winsock = Nothing ' dispose the ClientWinsock object
        Me.Dispose(True)
        Me.Close()
    End Sub
End Class
